commit 501021256aacc432d237fc4767cb378cd535d7b5
Author: jklowden <jklowden>
Date:   Sun Feb 7 21:56:09 2010 +0000

    Default bad client charset name to ISO 8859-1,  and avoid TDSEPORTINSTANCE when one of port/instance came from the [default] section.

diff --git a/include/sybdb.h b/include/sybdb.h
index 8f0cb20..9f849a8 100644
--- a/include/sybdb.h
+++ b/include/sybdb.h
@@ -41,7 +41,7 @@ extern "C"
 #define TDS_STATIC_CAST(type, a) ((type)(a))
 #endif
 
-static const char rcsid_sybdb_h[] = "$Id: sybdb.h,v 1.91 2009/08/25 14:25:35 freddy77 Exp $";
+static const char rcsid_sybdb_h[] = "$Id: sybdb.h,v 1.92 2010/02/07 21:56:09 jklowden Exp $";
 static const void *const no_unused_sybdb_h_warn[] = { rcsid_sybdb_h, no_unused_sybdb_h_warn };
 
 #ifdef FALSE
@@ -786,6 +786,7 @@ DBINT dbvarylen(DBPROCESS * dbproc, int column);
 				/* cf. doc/dblib_errors.txt for more iconv error values. */
 				/* Reserve a few slots for other iconv-related issues. */
 #define SYBETDSVER	 2410 	/* Cannot bcp with TDSVER < 5.0 */
+#define SYBEPORT	 2500	/* Both port and instance specified */
 #define SYBESYNC        20001	/* Read attempted while out of synchronization with SQL Server. */
 #define SYBEFCON        20002	/* SQL Server connection failed. */
 #define SYBETIME        20003	/* SQL Server connection timed out. */
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index 035d17f..00f6e44 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -75,7 +75,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.362 2010/01/28 05:35:55 jklowden Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.363 2010/02/07 21:56:09 jklowden Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -7477,6 +7477,9 @@ static const DBLIB_ERROR_MESSAGE dblib_error_messages[] =
 	, { SYBEICONVI,      EXCONVERSION,	"Some character(s) could not be converted into client's character set.  Unconverted "
 						"bytes were changed to question marks ('?')\0" }
 	, { SYBEICONV2BIG,   EXCONVERSION,	"Buffer overflow converting characters from client into server's character set\0" }
+	
+	
+	, { SYBEPORT, 	   	   EXUSER,	"Both port and instance specified\0" }
 	, { SYBETDSVER, 	   EXUSER,	"Cannot bcp with TDSVER < 5.0\0" }
 	, { SYBEAAMT,           EXPROGRAM,	"User attempted a dbaltbind with mismatched column and variable types\0" }
 	, { SYBEABMT,           EXPROGRAM,	"User attempted a dbbind with mismatched column and variable types\0" }
diff --git a/src/tds/config.c b/src/tds/config.c
index 96cbd9c..678f35a 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -36,6 +36,10 @@
 #include <stdlib.h>
 #endif /* HAVE_STDLIB_H */
 
+#if HAVE_LIMITS_H
+#include <limits.h>
+#endif 
+
 #if HAVE_STRING_H
 #include <string.h>
 #endif /* HAVE_STRING_H */
@@ -76,7 +80,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.157 2010/01/29 18:57:03 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.158 2010/02/07 21:56:10 jklowden Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -376,11 +380,30 @@ tds_read_conf_file(TDSCONNECTION * connection, const char *server)
 static int
 tds_read_conf_sections(FILE * in, const char *server, TDSCONNECTION * connection)
 {
+	TDSCONNECTION defaults;
+	int found;
+
 	tds_read_conf_section(in, "global", tds_parse_conf_section, connection);
+
 	if (!server[0])
 		return 0;
 	rewind(in);
-	return tds_read_conf_section(in, server, tds_parse_conf_section, connection);
+	defaults = *connection;
+
+	found = tds_read_conf_section(in, server, tds_parse_conf_section, connection);
+	
+	/* 
+	 * If both instance and port are specified and neither one came from the default, it's an error 
+	 * TODO: If port/instance is specified in the non-default, it has priority over the default setting. 
+	 * TODO: test this. 
+	 */
+	if (!tds_dstr_isempty(&connection->instance_name) && connection->port && 
+	  !(!tds_dstr_isempty(   &defaults.instance_name) ||    defaults.port)) {
+		tdsdump_log(TDS_DBG_ERROR, "error: cannot specify both port %d and instance %s.\n", 
+						connection->port, tds_dstr_cstr(&connection->instance_name));
+		/* tdserror(tds->tds_ctx, tds, TDSEPORTINSTANCE, 0); */
+	}
+	return found;
 }
 
 static const struct {
@@ -539,11 +562,10 @@ tds_parse_conf_section(const char *option, const char *value, void *param)
 		tds_dstr_copy(&connection->dump_file, value);
 	} else if (!strcmp(option, TDS_STR_DEBUGFLAGS)) {
 		char *end;
-		long l;
-		errno = 0;
-		l = strtol(value, &end, 0);
-		if (errno == 0 && *end == 0)
-			connection->debug_flags = l;
+		long flags;
+		flags = strtol(value, &end, 0);
+		if (*value != '\0' && *end == '\0' && flags != LONG_MIN && flags != LONG_MAX)
+			connection->debug_flags = flags;
 	} else if (!strcmp(option, TDS_STR_TIMEOUT) || !strcmp(option, TDS_STR_QUERY_TIMEOUT)) {
 		if (atoi(value))
 			connection->query_timeout = atoi(value);
diff --git a/src/tds/iconv.c b/src/tds/iconv.c
index ae34f98..7620f5f 100644
--- a/src/tds/iconv.c
+++ b/src/tds/iconv.c
@@ -49,7 +49,7 @@
 /* define this for now; remove when done testing */
 #define HAVE_ICONV_ALWAYS 1
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.141 2009/10/01 09:48:43 freddy77 Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.142 2010/02/07 21:56:10 jklowden Exp $");
 
 #define CHARSIZE(charset) ( ((charset)->min_bytes_per_char == (charset)->max_bytes_per_char )? \
 				(charset)->min_bytes_per_char : 0 )
@@ -204,8 +204,8 @@ tds_iconv_init(void)
 /**
  * Get iconv name given canonic
  */
-static void
-tds_get_iconv_name(int charset)
+static const char *
+tds_set_iconv_name(int charset)
 {
 	int i;
 	iconv_t cd;
@@ -217,13 +217,13 @@ tds_get_iconv_name(int charset)
 	if (cd != (iconv_t) -1) {
 		iconv_names[charset] = canonic_charsets[charset].name;
 		tds_sys_iconv_close(cd);
-		return;
+		return iconv_names[charset];
 	}
 	cd = tds_sys_iconv_open(ucs2name, canonic_charsets[charset].name);
 	if (cd != (iconv_t) -1) {
 		iconv_names[charset] = canonic_charsets[charset].name;
 		tds_sys_iconv_close(cd);
-		return;
+		return iconv_names[charset];
 	}
 
 	/* try all alternatives */
@@ -235,19 +235,20 @@ tds_get_iconv_name(int charset)
 		if (cd != (iconv_t) -1) {
 			iconv_names[charset] = iconv_aliases[i].alias;
 			tds_sys_iconv_close(cd);
-			return;
+			return iconv_names[charset];
 		}
 
 		cd = tds_sys_iconv_open(ucs2name, iconv_aliases[i].alias);
 		if (cd != (iconv_t) -1) {
 			iconv_names[charset] = iconv_aliases[i].alias;
 			tds_sys_iconv_close(cd);
-			return;
+			return iconv_names[charset];
 		}
 	}
 
-	/* charset not found, use memcpy */
-	iconv_names[charset] = "";
+	/* charset not found, pretend it's ISO 8859-1 */
+	iconv_names[charset] = canonic_charsets[POS_ISO1].name;
+	return NULL;
 }
 
 static void
@@ -474,19 +475,19 @@ tds_iconv_info_init(TDSICONV * char_conv, const char *client_name, const char *s
 	}
 
 	/* get iconv names */
-	if (!iconv_names[client_canonical])
-		tds_get_iconv_name(client_canonical);
-	if (!iconv_names[server_canonical])
-		tds_get_iconv_name(server_canonical);
-
-	/* names available ?? */
-	if (!iconv_names[client_canonical][0] || !iconv_names[server_canonical][0]) {
-		char_conv->to_wire = (iconv_t) -1;
-		char_conv->from_wire = (iconv_t) -1;
-		char_conv->flags = TDS_ENCODING_MEMCPY;
-		tdsdump_log(TDS_DBG_FUNC, "tds_iconv_info_init: use memcpy to convert \"%s\"->\"%s\"\n", client->name,
-			    server->name);
-		return 0;
+	if (!iconv_names[client_canonical]) {
+		if (!tds_set_iconv_name(client_canonical)) {
+			tdsdump_log(TDS_DBG_FUNC, "\"%s\" not supported by iconv, using \"%s\" instead\n",
+						  client_name, iconv_names[client_canonical]);
+		}
+	}
+	
+	assert(iconv_names[server_canonical]);
+	if (!iconv_names[server_canonical]) {
+		if (!tds_set_iconv_name(server_canonical)) {
+			tdsdump_log(TDS_DBG_FUNC, "\"%s\" not supported by iconv, using \"%s\" instead\n",
+						  server_name, iconv_names[server_canonical]);
+		}
 	}
 
 	char_conv->to_wire = tds_sys_iconv_open(iconv_names[server_canonical], iconv_names[client_canonical]);
diff --git a/src/tds/login.c b/src/tds/login.c
index ccca13c..3cbcaf9 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.194 2010/01/26 11:21:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.195 2010/02/07 21:56:10 jklowden Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -427,11 +427,6 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 		return TDSECONN;
 	}
 
-	if (connection->port && !tds_dstr_isempty(&connection->instance_name)) {
-		tdserror(tds->tds_ctx, tds, TDSEPORTINSTANCE, 0);
-		return TDSECONN;
-	}
-
 	if (!IS_TDS50(tds) && !tds_dstr_isempty(&connection->instance_name))
 		connection->port = tds7_get_instance_port(tds_dstr_cstr(&connection->ip_addr), tds_dstr_cstr(&connection->instance_name));
 
diff --git a/src/tds/util.c b/src/tds/util.c
index 45bdb7e..20935be 100644
--- a/src/tds/util.c
+++ b/src/tds/util.c
@@ -65,7 +65,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: util.c,v 1.89 2010/01/11 18:14:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: util.c,v 1.90 2010/02/07 21:56:10 jklowden Exp $");
 
 void
 tds_set_parent(TDSSOCKET * tds, void *the_parent)
@@ -255,7 +255,7 @@ static const TDS_ERROR_MESSAGE tds_error_messages[] =
 	, { TDSEICONVI,      EXCONVERSION,	"Some character(s) could not be converted into client's character set.  "
 						"Unconverted bytes were changed to question marks ('?')" }
 	, { TDSEICONV2BIG,   EXCONVERSION,	"Some character(s) could not be converted into client's character set" }
-	, { TDSEPORTINSTANCE,      EXCOMM,      "Both port and instance specified" }
+	, { TDSEPORTINSTANCE,      EXUSER,      "Both port and instance specified" }
 	, { TDSERPND,           EXPROGRAM,	"Attempt to initiate a new Adaptive Server operation with results pending" }
 	, { TDSEBTOK,              EXCOMM,	"Bad token from the server: Datastream processing out of sync" }
 	, { TDSECAP,               EXCOMM,	"DB-Library capabilities not accepted by the Server" }

